#include <mem.h>
#include <i86.h>
#include <stdio.h>

#include "types.h"
#include "dos4gw.h"

struct Tdos4gwregs {
  long edi;
  long esi;
  long ebp;
  long qqq;
  long ebx;
  long edx;
  long ecx;
  long eax;
  word flags;
  word es;
  word ds;
  word fs;
  word gs;
  word ip;
  word cs;
  word sp;
  word ss;
};

void *realtoflat(void *a)
{
  return (void *)((word)a+((((dword)a)>>12)&(~15)));
}

int dosalloc_asm(dword size,void *adr,word *selector);

int dosalloc(dword size,void *adr,word *selector)
{
#pragma aux dosalloc_asm = \
  "    xor  ecx,ecx"       \
  "    dec  ebx"           \
  "    shr  ebx,4"         \
  "    inc  ebx"           \
  "    cmp  ebx,65536"     \
  "    jae  qq"            \
  "    mov  eax,100h"      \
  "    int  31h"           \
  "    jc   qq"            \
  "    and  eax,65535"     \
  "    shl  eax,4"         \
  "    mov  [esi],eax"     \
  "    mov  [edi],dx"      \
  "    inc  ecx"           \
  "qq:"                    \
  parm [ebx] [esi] [edi]   \
  value [ecx]              \
  modify [eax ebx ecx edx esi edi];
  return dosalloc_asm(size,adr,selector);
}

byte dosfree_asm(word selector);

int dosfree(word selector)
{
#pragma aux dosfree_asm = \
  "mov  eax,101h"         \
  "int  31h"              \
  "lahf"                  \
  parm [dx]               \
  value [ah]              \
  modify [eax ebx ecx edx esi edi];
  return (dosfree_asm(selector)&1)==0;
}

byte int16_asm(int int_no,void far *regs);

int int16(int int_no,REGPACKX *r)
{
  Tdos4gwregs regs;

  regs.eax=r->eax;
  regs.ebx=r->ebx;
  regs.ecx=r->ecx;
  regs.edx=r->edx;
  regs.esi=r->esi;
  regs.edi=r->edi;
  regs.ebp=r->ebp;
  regs.flags=0;
  regs.ds=r->ds;
  regs.es=r->es;
  regs.fs=r->fs;
  regs.gs=r->gs;
  regs.ss=0;
  regs.sp=0;
  regs.ip=0;
#pragma aux int16_asm = \
  "push es"             \
  "mov  es,dx"          \
  "mov  eax,300h"       \
  "xor  ecx,ecx"        \
  "int  31h"            \
  "lahf"                \
  "pop  es"             \
  parm [ebx] [dx edi]   \
  value [ah]            \
  modify [eax ebx ecx edx esi edi];
  if (int16_asm(int_no,&regs)&1) return 0;
  r->eax=regs.eax;
  r->ebx=regs.ebx;
  r->ecx=regs.ecx;
  r->edx=regs.edx;
  r->esi=regs.esi;
  r->edi=regs.edi;
  r->ebp=regs.ebp;
  r->flags=regs.flags;
  r->ds=regs.ds;
  r->es=regs.es;
  r->fs=regs.fs;
  r->gs=regs.gs;
  return 1;
}

int getlinear_asm(dword phys,dword size,void *linear);

int getlinear(dword phys,dword size,char **linear)
{
#pragma aux getlinear_asm = \
  "    mov  eax,800h"       \
  "    shld ebx,ecx,16"     \
  "    shld esi,edi,16"     \
  "    int  31h"            \
  "    mov  eax,0"          \
  "    jc   qq"             \
  "    shl  ebx,16"         \
  "    mov  bx,cx"          \
  "    mov  [edx],ebx"      \
  "    inc  eax"            \
  "qq:"                     \
  parm [ecx] [edi] [edx]    \
  value [eax]               \
  modify [eax ebx ecx edx esi edi];
  return getlinear_asm(phys,size,linear);
}

byte freelinear_asm(char *linear);

int freelinear(char *linear)
{
#pragma aux freelinear_asm = \
  "mov  eax,801h"            \
  "shld ebx,ecx,16"          \
  "int  31h"                 \
  "lahf"                     \
  parm [ecx]                 \
  value [ah]                 \
  modify [eax ebx ecx edx esi edi];
  return (freelinear_asm(linear)&1)==0;
}

byte lockregion_asm(void *address,dword length);

int lockregion(void *address,dword length)
{
#pragma aux lockregion_asm = \
  "mov  eax,600h"            \
  "shld ebx,ecx,16"          \
  "shld esi,edi,16"          \
  "int  31h"                 \
  "lahf"                     \
  parm [ecx] [edi]           \
  value [ah]                 \
  modify [eax ebx ecx edx esi edi];
  return (lockregion_asm(address,length)&1)==0;
}
