#include <time.h>
#include <malloc.h>
#include <dos.h>
#include <mem.h>
#include <conio.h>
#include <stdio.h>

#include "dos4gw.h"
#include "vbe20.h"
#include "grtext.h"
#define _GRLIB_CPP
#include "grlib.h"

int FrameCount;
int FrameCount0;
dword FrameTime;
dword FrameTime0;
int backpage;
int pagesize;
volatile int exitfl;
char *sysbuffer=NULL;

#define MAXEV 20

Tevent events[MAXEV];
int evnum;

void (interrupt far *oldint9)(void)=NULL;

#define ESCKEY 1

TGRapp::TGRapp(char *_title)
{
  title=_title;
  grapp=this;
}

TGRapp::~TGRapp( void )
{
}

int TGRapp::setmode(int width,int height,int bpp)
{
  Tcolor pal[256];

  short m=VBEfindmode(width,height,bpp);
  if (m==0) return 0;
  if (!VBEsetmode(m)) return 0;
  if (bpp==8) VBEsetdac8();
  scr_cols=width;
  scr_rows=height;
  scr_bpp=bpp;
  scr_ox=width/2;
  scr_oy=height/2;
  buffer=VBEbuffer;
  backpage=0;
  FrameCount=0;
  FrameTime0=0;
  pagesize=scr_cols*scr_rows*VBEmode.BitsPerPixel/8;
  if (sysbuffer!=NULL) {
    free(sysbuffer);
    sysbuffer=NULL;
  }
  if (VBEmode.NumberOfImagePages==0) {
    sysbuffer=(char *)malloc(pagesize);
    if (sysbuffer==NULL) return 0;
  }
  if (bpp==8 && palette!=NULL) {
    for (int i=0;i<256;i++) {
      pal[i].r=palette[i].r>>(8-VBEdac);
      pal[i].g=palette[i].g>>(8-VBEdac);
      pal[i].b=palette[i].b>>(8-VBEdac);
    }
    if (!VBEsetpal(pal,0,256)) return 0;
  }
  return 1;
}

void TGRapp::oneframe( void )
{
  if (VBEmode.NumberOfImagePages>0)
    buffer=VBEbuffer+pagesize*backpage;
  else
    buffer=sysbuffer;
  memset(buffer,0,pagesize);
  draw();
  for (int i=0;i<evnum;i++)
    eventhandler(events+i);
  evnum=0;
  FrameCount++;
  FrameTime=clock();
  if (FrameTime-FrameTime0>CLOCKS_PER_SEC) {
    FrameRate=(FrameCount-FrameCount0)*CLOCKS_PER_SEC/(FrameTime-FrameTime0);
    FrameTime0=FrameTime;
    FrameCount0=FrameCount;
  }
  if (VBEmode.NumberOfImagePages>0) {
    VBEsetpage(backpage);
    backpage=1-backpage;
  }
  else memcpy(VBEbuffer,buffer,pagesize);
}

void TGRapp::textout(int x,int y,char *s)
{
  textout_asm(buffer+y*scr_cols+x,s,0xFFFFFF);
}


int GRrgb(int r,int g,int b)
{
  return ((r>>(8-VBEmode.RedMaskSize))<<VBEmode.RedFieldPosition)+
         ((g>>(8-VBEmode.GreenMaskSize))<<VBEmode.GreenFieldPosition)+
         ((b>>(8-VBEmode.BlueMaskSize))<<VBEmode.BlueFieldPosition);
}

void GRtorgb(int col,unsigned char *r,unsigned char *g,unsigned char *b)
{
  *r=(col>>VBEmode.RedFieldPosition)<<(8-VBEmode.RedMaskSize);
  *g=(col>>VBEmode.GreenFieldPosition)<<(8-VBEmode.GreenMaskSize);
  *b=(col>>VBEmode.BlueFieldPosition)<<(8-VBEmode.BlueMaskSize);
}

void keyboard_lock_region_begin( void )
{
}

void _loadds interrupt kbdhandler( void )
{
  char p;

  p=(char)inp(0x60);
  if (p==ESCKEY) exitfl=1;
  else if (evnum<MAXEV) {
    events[evnum].type=evKEY;
    events[evnum].time=0;
    events[evnum].data=p^128;
    evnum++;
  }
  outp(0x20,0x20);
}

//Dummy function to indicate org of the code to lock
void keyboard_lock_region_end( void )
{
}

int hookkbd( void )
{
  if (!lockregion( (void *) keyboard_lock_region_begin,
                 (char *) keyboard_lock_region_end -
                 (char *) keyboard_lock_region_begin )) return 0;
  oldint9=_dos_getvect(9);
  _dos_setvect(9,kbdhandler);
  return 1;
}

void dbkkooh( void )
{
  if (oldint9!=NULL) _dos_setvect(9,oldint9);
}

int changemode( void )
{
  int i;

  VBEsettext();
 qqq:
  printf("Available modes:\n");
  for (i=0;i<VBEmodenum;i++) {
    if (i%3==0) printf("\n");
    printf("%2d) %4dx%4dx%2d     ",i+1,VBEmodes[i].width,VBEmodes[i].height,VBEmodes[i].bpp);
  }
  printf("\nSelect mode (0 to exit): ");
  scanf("%d",&i);
  if (i<1 || i>VBEmodenum) return 0;
  if (!grapp->setmode(VBEmodes[i-1].width,VBEmodes[i-1].height,VBEmodes[i-1].bpp)) {
    VBEsettext();
    printf("Failed to set mode.\n");
    goto qqq;
  }
  return 1;
}

void main( void )
{
  if (!VBEinit()) {
    VBEtini();
    printf("Fail to init VBE 2.0.\n");
    return;
  }
  if (!grapp->init()) goto qqq;
 next:
  if (!hookkbd()) goto qqq;
  exitfl=0;
  while (!exitfl)
    grapp->oneframe();
  dbkkooh();
  if (changemode()) goto next;
 qqq:
  if (sysbuffer!=NULL) free(sysbuffer);
  grapp->tini();
  VBEtini();
}
