#ifndef _GRLIB_H
#define _GRLIB_H

#ifdef _MSC_VER
#define __WINDOWS__
#endif

#ifdef __WATCOMC__
#include <mem.h>
#else
#include <memory.h>
#endif
#ifdef __WINDOWS__
#include <windows.h>
#endif

struct Trgb {
  unsigned char r,g,b;
};

struct Tevent {
  int type;
  int time;
  int data;
};

#define evKEY 1

class TGRapp {
  public:
    char *buffer;
    char *title;
    Trgb *palette;

    TGRapp(char *_title);
    ~TGRapp( void );
    void textout(int x,int y,char *s);
    void oneframe( void );
    virtual int init( void )=0;
    virtual void tini( void )=0;
    virtual int setmode(int width,int height,int bpp);
    virtual void draw( void )=0;
    virtual void eventhandler(Tevent *ev)=0;
#ifdef __WINDOWS__
    virtual int wndproc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)=0;
#endif
};

#ifdef _GRLIB_CPP
  char *buffer;
  int scr_ox,scr_oy,scr_cols,scr_rows,scr_bpp;
  int FrameRate;
  TGRapp *grapp;
#else
  extern char *buffer;
  extern int scr_ox,scr_oy,scr_cols,scr_rows,scr_bpp;
  extern int FrameRate;
  extern TGRapp *grapp;
#endif

#ifdef __WATCOMC__
#pragma aux scr_ox "scr_ox"
#pragma aux scr_oy "scr_oy"
#pragma aux scr_cols "scr_cols"
#pragma aux scr_rows "scr_rows"
#pragma aux scr_bpp "scr_bpp"
#endif

int GRrgb(int r,int g,int b);
void GRtorgb(int col,unsigned char *r,unsigned char *g,unsigned char *b);

#endif
