#include <mem.h>

#include "types.h"
#define _VBE20_CPP
#include "vbe20.h"
#include "dos4gw.h"

TVbeInfo *pinfo=NULL;
TModeInfo *pmode=NULL;
Tcolor *ppal=NULL;
word infosel,modesel,palsel;

int VBEinit( void )
{
  REGPACKX r;
  short *modep;

  if (!dosalloc(sizeof(TVbeInfo),&pinfo,&infosel)) return 0;
  if (!dosalloc(sizeof(TModeInfo),&pmode,&modesel)) return 0;
  if (!dosalloc(256*sizeof(Tcolor),&ppal,&palsel)) return 0;
  memcpy(pinfo,&VBEinfo,sizeof(TVbeInfo));
  r.eax=0x4F00;
  r.es=(dword)pinfo>>4;
  r.edi=0;
  if (!int16(0x10,&r)) return 0;
  memcpy(&VBEinfo,pinfo,sizeof(TVbeInfo));
  if ((word)r.eax!=0x4F) return 0;
  if (VBEinfo.VbeVersion<0x200) return 0;

  VBEinfo.OemStringPtr=(char  *)realtoflat(VBEinfo.OemStringPtr);
  VBEinfo.VideoModePtr=(short *)realtoflat(VBEinfo.VideoModePtr);
  VBEinfo.OemVendorNamePtr=(char *)realtoflat(VBEinfo.OemVendorNamePtr);
  VBEinfo.OemProductRevPtr=(char *)realtoflat(VBEinfo.OemProductRevPtr);
  VBEinfo.OemProductNamePtr=(char *)realtoflat(VBEinfo.OemProductNamePtr);
  modep=VBEinfo.VideoModePtr;
  VBEmodenum=0;
  for (;*modep!=-1;modep++) {
    if (!VBEgetmodeinfo(*modep)) continue;
    if ((VBEmode.ModeAttributes&0x90)!=0x90) continue;
    if (VBEmode.BitsPerPixel!=8 && VBEmode.BitsPerPixel!=16 &&
        VBEmode.BitsPerPixel!=24 && VBEmode.BitsPerPixel!=32) continue;
    VBEmodes[VBEmodenum].number=*modep;
    VBEmodes[VBEmodenum].width=VBEmode.XResolution;
    VBEmodes[VBEmodenum].height=VBEmode.YResolution;
    VBEmodes[VBEmodenum].bpp=VBEmode.BitsPerPixel;
    VBEmodenum++;
  }
  if (VBEmodenum==0) return 0;
  return 1;
}

void VBEsettext( void )
{
  union REGS r;

  r.x.eax=3;
  int386(0x10,&r,&r);
}

void VBEtini( void )
{
  if (VBEbuffer!=NULL) freelinear(VBEbuffer);
  if (pinfo!=NULL) dosfree(infosel);
  if (pmode!=NULL) dosfree(modesel);
  if (ppal!=NULL) dosfree(palsel);
}

int VBEgetmodeinfo(short mode)
{
  REGPACKX r;

  r.eax=0x4F01;
  r.ecx=mode;
  r.es=(dword)pmode>>4;
  r.edi=0;
  if (!int16(0x10,&r)) return 0;
  memcpy(&VBEmode,pmode,sizeof(TModeInfo));
  VBEmode.WinFuncPtr=(char *)realtoflat(VBEmode.WinFuncPtr);
  return (word)r.eax==0x4F;
}

int VBEsetmode(short mode)
{
  union REGS r;

  r.w.ax=0x4F02;
  r.w.bx=mode|0x4000;
  if (!int386(0x10,&r,&r)) return 0;
  if (r.w.ax!=0x4F) return 0;
  VBEdac=6;
  if (!VBEgetmodeinfo(mode)) return 0;
  if (VBEbuffer!=NULL) freelinear(VBEbuffer);
  VBEbuffer=NULL;
  if (!getlinear(VBEmode.PhysBasePtr,VBEinfo.TotalMemory*65536,&VBEbuffer)) return 0;
  return 1;
}

int VBEfindmode(int width,int height,int bpp)
{
  for (int i=0;i<VBEmodenum;i++)
    if (VBEmodes[i].width==width && VBEmodes[i].height==height &&
        VBEmodes[i].bpp==bpp)
      return VBEmodes[i].number;
  return 0;
}

short VBEgetmode( void )
{
  union REGS r;

  r.w.ax=0x4F03;
  if (!int386(0x10,&r,&r)) return 0;
  if (r.w.ax!=0x4F) return 0;
  return r.w.bx;
}

int VBEsetstart(word x,word y)
{
  union REGS r;

  r.w.ax=0x4F07;
  r.w.bx=0x80;
  r.w.cx=x;
  r.w.dx=y;
  if (!int386(0x10,&r,&r)) return 0;
  return r.w.ax==0x4F;
}

int VBEgetstart(word *x,word *y)
{
  union REGS r;

  r.w.ax=0x4F07;
  r.w.bx=0;
  if (!int386(0x10,&r,&r)) return 0;
  if (r.w.ax!=0x4F) return 0;
  *x=r.w.cx;
  *y=r.w.dx;
  return 1;
}

int VBEsetpage(int page)
{
  if (page>VBEmode.NumberOfImagePages) return 0;
  return VBEsetstart(0,page*VBEmode.YResolution);
}

int VBEsetdac6( void )
{
  union REGS r;

  r.w.ax=0x4F08;
  r.w.bx=0x0600;
  if (!int386(0x10,&r,&r)) return 0;
  if (r.w.ax==0x4F) {
    VBEdac=6;
    return 1;
  }
  return 0;
}

int VBEsetdac8( void )
{
  union REGS r;

  r.w.ax=0x4F08;
  r.w.bx=0x0800;
  if (!int386(0x10,&r,&r)) return 0;
  if (r.w.ax==0x4F) {
    VBEdac=8;
    return 1;
  }
  return 0;
}

int VBEsetpal(Tcolor *pal,word first,word number)
{
  REGPACKX r;

  memcpy(ppal,pal,number*sizeof(Tcolor));
  r.eax=0x4F09;
  r.ebx=0;
  r.ecx=number;
  r.edx=first;
  r.es=(dword)ppal>>4;
  r.edi=0;
  if (!int16(0x10,&r)) return 0;
  return (word)r.eax==0x4F;
}

int VBEgetpal(Tcolor *pal,word first,word number)
{
  REGPACKX r;

  r.eax=0x4F09;
  r.ebx=1;
  r.ecx=number;
  r.edx=first;
  r.es=(dword)ppal>>4;
  r.edi=0;
  if (!int16(0x10,&r) || (word)r.eax!=0x4F) return 0;
  memcpy(ppal,pal,number*sizeof(Tcolor));
  return 1;
}
