#ifndef _VBE20_H
#define _VBE20_H

#include "types.h"

struct TVbeInfo {
  char  VbeSignature[4];
  word  VbeVersion;
  char *OemStringPtr;
  dword Capabilities;
  short *VideoModePtr;
  word  TotalMemory;
  word  OemSoftwareRev;
  char *OemVendorNamePtr;
  char *OemProductNamePtr;
  char *OemProductRevPtr;
  char  Reserved[222];
  char  OemData[256];
};

struct TModeInfo {
  word  ModeAttributes;
  byte  WinAAttributes;
  byte  WinBAttributes;
  word  WinGranularity;
  word  WinSize;
  word  WinASegment;
  word  WinBSegment;
  char *WinFuncPtr;
  word  BytesPerScanLine;
  word  XResolution;
  word  YResolution;
  byte  XCharSize;
  byte  YCharSize;
  byte  NumberOfPlanes;
  byte  BitsPerPixel;
  byte  NumberOfBanks;
  byte  MemoryModel;
  byte  BankSize;
  byte  NumberOfImagePages;
  byte  qqq1;
  byte  RedMaskSize;
  byte  RedFieldPosition;
  byte  GreenMaskSize;
  byte  GreenFieldPosition;
  byte  BlueMaskSize;
  byte  BlueFieldPosition;
  byte  RsvdMaskSize;
  byte  RsvdFieldPosition;
  byte  DirectColorModeInfo;
  dword PhysBasePtr;
  dword OffScreenMemOffset;
  word  OffScreenMemSize;
  char  qqq2[206];
};

struct Tcolor {
  unsigned char b;
  unsigned char g;
  unsigned char r;
  unsigned char qqq;
};


struct Tvbemode {
  short number;
  word  width;
  word  height;
  word  bpp;
};

#ifdef _VBE20_CPP
  char *VBEbuffer=NULL;
  TVbeInfo VBEinfo={{'V','B','E','2'}};
  TModeInfo VBEmode;
  int VBEdac;
  Tvbemode VBEmodes[256];
  int VBEmodenum=0;
#else
  extern char *VBEbuffer;
  extern TVbeInfo VBEinfo;
  extern TModeInfo VBEmode;
  extern int VBEdac;
  extern Tvbemode VBEmodes[256];
  extern int VBEmodenum;
#endif

int VBEinit( void );
void VBEtini( void );
int VBEgetmodeinfo(short mode);
int VBEsetmode(short mode);
void VBEsettext( void );
int VBEfindmode(int width,int height,int bpp);
short VBEgetmode( void );
int VBEsetstart(word x,word y);
int VBEgetstart(word *x,word *y);
int VBEsetpage(int page);
int VBEsetdac6( void );
int VBEsetdac8( void );
int VBEsetpal(Tcolor *pal,word first,word number);
int VBEgetpal(Tcolor *pal,word first,word number);

#endif
